#ifndef SSE3_EMULATE_INCLUDED
#define SSE3_EMULATE_INCLUDED 1
#ifndef __SSE3__
#define __SSE3__ 1
inline __m128 _mm_moveldup_ps(__m128 a)
{
	return _mm_shuffle_ps( a, a, 0xa0 );
}

inline __m128 _mm_movehdup_ps(__m128 a)
{
	return _mm_shuffle_ps( a, a, 0xf5 );
}

inline __m128 _mm_lddqu_si128( __m128i * a)
{
	return _mm_loadu_ps((float*) a );
}

inline __m128 _mm_hadd_ps(__m128 a, __m128 b)
{
	return _mm_add_ps(_mm_shuffle_ps(a,b,0x88), _mm_shuffle_ps(a,b,0xdd));
}

inline __m128 _mm_addsub_ps(__m128 a, __m128 b) 
{
	__m128 c = _mm_shuffle_ps(_mm_sub_ps(a, b),_mm_add_ps(a, b), 0xd8);
	return _mm_shuffle_ps(c, c, 0xd8);
}
#endif   /*  __SSE3__  emulation */

#endif   /* SSE3_EMULATE_INCLUDED */