// #include "ap_config.h"

#ifdef _WIN32
#include "windows.h"
#endif

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <algorithm>

// #include <ctype.h>

// #include "setilib.h"
// #include "db_table.h"
// #include "sqlhdr.h"
// #include "schema_master.h"
// #include "seti_doppler.h"

#include "parse.h"
#include "xml_util.h"
#include "db_table.h"
#include "ap_schema.h"
// #include "astropulse.h"
#include "util.h"
#include "base64.h"
#include "ap_raw_data_db.h"
#undef read

#include <cstring>
#include <cassert>
#include <cstdlib>
#include <cstdio>
#include <cerrno>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

int main(int argc, char* argv[]) {

  if(argc != 2) {
    printf("In display_signal_plot: error: wrong number of args.  Usage: display_signal_plot id");
    exit(-1);
  }

  int retval;
  ap_signal this_ap_signal;
  const char * test_db = "apb_db@sci_master_tcp";

  setenv("INFORMIXDIR", "/disks/thumper/a/apps/informix", 1);
  setenv("INFORMIXSQLHOSTS", "/disks/thumper/a/apps/informix/etc/sqlhosts", 1);
  setenv("INFORMIXSERVER", "sci_master_tcp", 1);

  printf("INFORMIXDIR = ");
  system("echo $INFORMIXDIR");
  printf("INFORMIXSQLHOSTS = ");
  system("echo $INFORMIXSQLHOSTS");
  printf("INFORMIXSERVER = ");
  system("echo $INFORMIXSERVER");

  retval = db_change(test_db);
  fprintf(stderr, "db_change(%s) returns %d\n", test_db, retval);

  char c_string[256];
  std::string where_clause;

  sprintf(c_string, "where id = %s", argv[1]); // writeout
  where_clause = c_string;
  this_ap_signal.open_query(where_clause);

  retval = this_ap_signal.get_next();
  std::string wufilename = "unknown_wu";
  Astropulse::ap_signal_to_miniwufile(this_ap_signal, wufilename); // write out
}
