/* splitter_bits_to_float header file */

#ifndef SBTF_H
#define SBTF_H
#include "intrinsics.h"
#include <string.h>
#include "fftw3.h"

#if (__SSE__ && SPLIT_COMPLEX) //uje: && !_GNU_SOURCE
int splitter_bits_to_float(unsigned char *raw, float *data, float* i_data,int nsamples);

/*#elif (__SSE__ && SPLIT_COMPLEX) && _GNU_SOURCE //uje: later trying to make SPLIT_COMPLEX work
int splitter_bits_to_float(unsigned char *raw, float *data, float* i_data,int nsamples);*/

#else
int splitter_bits_to_float(unsigned char *raw, float *data, int nsamples);
#endif
#endif


