#!/usr/bin/perl

if(!$ARGV[0]) {
  print "Usage: perl strip_tags_from_wu.perl <input filename>\n";
}

open(INFILE, $ARGV[0]);
open(OUTFILE, ">" . $ARGV[0] . ".strip");

$mode = 1;
$total_length = 0;
$numlines = 0;

while($line = <INFILE>) {
  $numlines++;
  if($mode == 1) {
    if($line =~ /^<data length=8388608 encoding="binary">/) {
      $mode = 2;
      $firstline = substr($line, 39);
      print OUTFILE $firstline;
      $total_length += length($firstline);
    } 
  } elsif($mode == 2) {
    if($line =~ /^(.*)<\/data>$/) {
      print OUTFILE $1;
      $total_length += length($1);
      print "Total length: $total_length\n";
      print "Number of lines: " . $numlines . "\n";
      exit(0);
    } else {
      print OUTFILE $line;
      $total_length += length($line);
    }
  }
}

print "Abnormal exit.\n";

