// #include "ap_config.h"

#ifdef _WIN32
#include "windows.h"
#endif

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <algorithm>

// #include <ctype.h>

// #include "setilib.h"
// #include "db_table.h"
// #include "sqlhdr.h"
// #include "schema_master.h"
// #include "seti_doppler.h"

#include "parse.h"
#include "xml_util.h"
#include "db_table.h"
#include "ap_schema.h"
// #include "astropulse.h"
#include "util.h"
#include "base64.h"
#include "ap_raw_data_db.h"
#undef read

#include <cstring>
#include <cassert>
#include <cstdlib>
#include <cstdio>
#include <cerrno>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

int main(int argc, char* argv[]) {

  int retval,updateretval;
  ap_signal this_ap_signal;
  const char * test_db = "apb_db@sci_master_tcp";

  retval = db_change(test_db);
  fprintf(stderr, "db_change(%s) returns %d\n", test_db, retval);

  char c_string[256];
  std::string where_clause;

  // *** sprintf(c_string, "where id = 246375"); // insertion
  sprintf(c_string, "where id = 291800"); // writeout
  where_clause = c_string;
  this_ap_signal.open_query(where_clause);

  // while (retval = this_ap_signal.get_next()) {
  retval = this_ap_signal.get_next();
  printf("this_ap_signal.ra = %f\n", this_ap_signal.ra);
  printf("this_ap_signal.peak_power = %f\n", this_ap_signal.peak_power);
  std::string wufilename = "testwu_20295509.wu";
  // *** sprintf(this_ap_signal.raw_data, "%s", Astropulse::make_raw_data_string(wufilename, 20295509).c_str()); // insertion
  // *** this_ap_signal.insert(); // insertion
  Astropulse::ap_signal_to_miniwufile(this_ap_signal, wufilename); // write out
  // }
}
